package de.howaner.Pokemon;

import com.google.common.collect.Queues;
import java.util.Queue;

public class Scheduler {
	private Queue<Runnable> toCall = Queues.newConcurrentLinkedQueue();

	public void tick() {
		while (!this.toCall.isEmpty()) {
			this.toCall.poll().run();
		}
	}

	public void runTaskSync(Runnable runnable) {
		if (PokemonServer.getServer().isServerThread()) {
			runnable.run();
		} else {
			this.toCall.add(runnable);
		}
	}

}
