package de.howaner.Pokemon.config;

import lombok.Getter;

public class DatabaseConfig {
	@Getter private String mongoIP;
	@Getter private int mongoPort;
	@Getter private String mongoUser;
	@Getter private String mongoPass;
	@Getter private String database;

	public void read(IniParser parser) {
		IniSection section = parser.getSection("Database");
		if (section == null) section = parser.createSection("Database");

		section.setIfNotAvailable("MongoIP", "127.0.0.1");
		section.setIfNotAvailable("MongoPort", 27017);
		section.setIfNotAvailable("MongoUser", "Pokemon");
		section.setIfNotAvailable("MongoPassword", "");
		section.setIfNotAvailable("Database", "Pokemon");

		this.mongoIP = section.getString("MongoIP");
		this.mongoPort = section.getInteger("MongoPort");
		this.mongoUser = section.getString("MongoUser");
		this.mongoPass = section.getString("MongoPassword");
		this.database = section.getString("Database");
	}

}
