package de.howaner.Pokemon.config;

import java.io.File;
import lombok.Getter;

public class ServerConfig {
	public File configFile = new File("settings.ini");

	@Getter private int serverPort = 9334;
	@Getter private String serverIP = "0.0.0.0";
	@Getter private int maxPlayers = 50;
	private boolean useJLine = true;

	@Getter private DatabaseConfig databaseConfig;

	public void readConfig() throws Exception {
		IniParser parser = new IniParser(configFile);
		if (this.configFile.exists()) {
			parser.read();
		}

		IniSection section = parser.getSection("Server");
		if (section == null) section = parser.createSection("Server");
		section.setIfNotAvailable("ServerPort", 1337);
		section.setIfNotAvailable("ServerIP", "0.0.0.0");
		section.setIfNotAvailable("MaxPlayers", 50);
		section.setIfNotAvailable("UseJLine", true);

		this.serverPort = section.getInteger("ServerPort");
		this.serverIP = section.getString("ServerIP");
		this.maxPlayers = section.getInteger("MaxPlayers");
		this.useJLine = section.getBoolean("UseJLine");

		this.databaseConfig = new DatabaseConfig();
		this.databaseConfig.read(parser);

		parser.write();
	}

	public boolean isJLineEnabled() {
		return this.useJLine;
	}

	public void setUseJLine(boolean useJLine) {
		this.useJLine = useJLine;
	}

}
