package de.howaner.Pokemon.console;

import de.howaner.Pokemon.console.QueueLogAppender;
import de.howaner.Pokemon.PokemonServer;
import java.io.IOException;
import java.io.OutputStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import jline.console.ConsoleReader;

public class TerminalConsoleWriterThread implements Runnable {
	private final ConsoleReader reader;
	private final OutputStream output;

	public TerminalConsoleWriterThread(OutputStream output, ConsoleReader reader) {
		this.output = output;
		this.reader = reader;
	}

	@Override
	public void run() {
		while (true) {
			String message = QueueLogAppender.getNextLogEvent("TerminalConsole");
			if (message != null) {
				try {
					if (PokemonServer.getServer().getConfig().isJLineEnabled()) {
						this.reader.print("\r");
						this.reader.flush();
						this.output.write(message.getBytes());
						this.output.flush();
						try {
							this.reader.drawLine();
						} catch (Throwable ex) {
							this.reader.getCursorBuffer().clear();
						}
						this.reader.flush();
					} else {
						this.output.write(message.getBytes());
						this.output.flush();
					}
				} catch (IOException ex) {
					Logger.getLogger(TerminalConsoleWriterThread.class.getName()).log(Level.SEVERE, null, ex);
				}
			}
		}
	}
}
