package de.howaner.Pokemon.console;

import de.howaner.Pokemon.PokemonServer;
import jline.console.ConsoleReader;

public class ThreadCommandReader extends Thread {

	public ThreadCommandReader() {
		super("Server console handler");
	}

	@Override
	public void run() {
		PokemonServer server = PokemonServer.getServer();
		ConsoleReader reader = server.getConsoleReader();

		try {
			while (server.isRunning()) {
				String command;
				if (server.getConfig().isJLineEnabled()) {
					command = reader.readLine(">", null);
				} else {
					command = reader.readLine();
				}

				if (command != null) {
					server.getCommandManager().queueCommand(command);
				}
			}
		} catch (Exception ex) {
			server.getLogger().error("Exception handling console input", ex);
		}
	}

}
