package de.howaner.Pokemon.database;

import com.mongodb.BasicDBObject;
import com.mongodb.DB;
import com.mongodb.DBCollection;
import com.mongodb.DBCursor;
import com.mongodb.DBObject;
import com.mongodb.Mongo;
import com.mongodb.MongoClient;
import com.mongodb.MongoCredential;
import com.mongodb.ServerAddress;
import de.howaner.Pokemon.util.Location;
import java.util.Arrays;
import lombok.Getter;

public class Database {
	@Getter private Mongo client;
	@Getter private DB database;

	public void connect(String ip, int port, String username, String password, String database) throws Exception {
		this.client = new MongoClient(new ServerAddress(ip, port), Arrays.asList(MongoCredential.createCredential(username, database, password.toCharArray())));
		this.database = this.client.getDB(database);
	}

	public DatabasePlayer getPlayer(String name) {
		DBCollection collection = this.database.getCollection("players");
		DBCursor cursor = collection.find(new BasicDBObject("Name", name));

		if (!cursor.hasNext()) {
			cursor.close();
			return null;
		}

		DBObject obj = cursor.next();
		DatabasePlayer player = new DatabasePlayer(name);
		player.setPasswordHash((String) obj.get("PasswordHash"));
		player.setCreateTime((Long) obj.get("CreateTime"));
		player.setLocation(Location.fromJson((String) obj.get("Location")));

		return player;
	}

	public void setPlayer(DatabasePlayer player) {
		DBCollection collection = this.database.getCollection("players");
		
		BasicDBObject obj = new BasicDBObject("Name", player.getName());
		obj.put("PasswordHash", player.getPasswordHash());
		obj.put("CreateTime", player.getCreateTime());
		obj.put("Location", Location.toJson(player.getLocation()));
		
		collection.update(new BasicDBObject("Name", player.getName()), obj, true, false);
	}

}
