package de.howaner.Pokemon.database;

import de.howaner.Pokemon.PokemonServer;
import lombok.Getter;

public class DatabaseManager {
	@Getter private final Database database;
	@Getter private final DatabaseQueue queue;

	public DatabaseManager(Database database) {
		this.database = database;
		this.queue = new DatabaseQueue();
		this.queue.start();
	}

	public void getPlayer(final String name, final DatabaseCallback<DatabasePlayer> callback) {
		this.queue.addRunnable(new Runnable() {
			@Override
			public void run() {
				DatabaseManager.this.syncCallbackCall(callback, DatabaseManager.this.getDatabase().getPlayer(name));
			}
		});
	}

	public void setPlayer(final DatabasePlayer player) {
		this.queue.addRunnable(new Runnable() {
			@Override
			public void run() {
				DatabaseManager.this.database.setPlayer(player);
			}
		});
	}

	private <T> void syncCallbackCall(final DatabaseCallback<T> callback, final T arg) {
		PokemonServer.getServer().getScheduler().runTaskSync(new Runnable() {
			@Override
			public void run() {
				callback.run(arg);
			}
		});
	}

}
