package de.howaner.Pokemon.database;

import com.google.common.collect.Queues;
import java.util.Queue;

public class DatabaseQueue extends Thread {
	private final Queue<Runnable> runnables = Queues.newConcurrentLinkedQueue();

	public DatabaseQueue() {
		super("Database Queue");
	}

	public void addRunnable(Runnable runnable) {
		this.runnables.add(runnable);
	}

	@Override
	public void run() {
		while (!this.isInterrupted()) {
			while (!this.runnables.isEmpty()) {
				this.runnables.poll().run();
			}

			try {
				Thread.sleep(50L);
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}

}