package de.howaner.Pokemon.entity;

import de.howaner.Pokemon.PokemonServer;
import de.howaner.Pokemon.network.ClientHandle;
import de.howaner.Pokemon.network.packets.out.PacketOutPlayerSpawn;
import de.howaner.Pokemon.network.packets.out.PacketOutSwitchWorld;
import de.howaner.Pokemon.network.packets.out.PacketOutUpdateEntityID;
import de.howaner.Pokemon.util.Location;
import de.howaner.Pokemon.world.World;
import de.howaner.Pokemon.world.WorldLoader;

public class Player extends Entity {
	private String name;
	private ClientHandle handle;

	public Player(Location loc, ClientHandle handle) {
		super(loc);
		this.handle = handle;
		this.name = handle.getUserName();
	}

	public String getName() {
		return this.name;
	}

	public ClientHandle getClientHandle() {
		return this.handle;
	}

	@Override
	public void switchWorld(final Location newLoc) {
		this.fadeOut(0.5f);
		this.getClientHandle().fadeOutScreen(0.5f);
		this.getClientHandle().sendPacket(new PacketOutSwitchWorld(newLoc));
		PokemonServer.getServer().getWorldManager().getWorldLoader().addWorldToQueue(newLoc.getWorld(), new WorldLoader.WorldLoadedCallback() {
			@Override
			public void onLoadedWorld(World world) {
				Player.this.getWorld().removeEntity(Player.this.getEntityID());
				Player.this.getLocation().set(world.getName(), newLoc.getPosX(), newLoc.getPosY());
				world.spawnEntity(Player.this);
				Player.this.getClientHandle().sendPacket(new PacketOutUpdateEntityID(Player.this.getEntityID()));

				for (Entity entity : world.getEntities()) {
					if (entity != Player.this && entity instanceof Player) {
						Player.this.getClientHandle().sendPacket(new PacketOutPlayerSpawn((Player) entity));
					}
				}

				Player.this.getClientHandle().fadeInScreen(0.5f);
				Player.this.fadeIn(0.5f);
			}
		});
	}

}
