package de.howaner.Pokemon.listener.event.entity;

import de.howaner.Pokemon.entity.Entity;
import de.howaner.Pokemon.listener.event.Cancellable;
import de.howaner.Pokemon.listener.event.Event;
import de.howaner.Pokemon.util.Location;

/**
 * Called when a entity finished the walk.
 */
public class EntityWalkedEvent extends Event implements Cancellable {
	private boolean cancelled = false;
	private Entity entity;
	private Location destinition;

	public EntityWalkedEvent(Entity entity, Location destinition) {
		this.entity = entity;
		this.destinition = destinition;
	}

	public Entity getEntity() {
		return this.entity;
	}

	public Location getDestinition() {
		return this.destinition;
	}

	@Override
	public boolean isCancelled() {
		return this.cancelled;
	}

	@Override
	public void setCancelled(boolean cancelled) {
		this.cancelled = cancelled;
	}

}
