package de.howaner.Pokemon.map.events;

import de.howaner.Pokemon.map.MapTerrain;
import de.howaner.Pokemon.saveformat.TagCompound;
import de.howaner.Pokemon.util.Location;

public abstract class Event {
	private final MapTerrain map;
	private Location position;

	public Event(MapTerrain map, int posX, int posY) {
		this.map = map;
		this.position = new Location(map.getName(), posX, posY);
	}

	public MapTerrain getMap() {
		return this.map;
	}

	public Location getPosition() {
		return this.position;
	}

	public void loadFromCompound(TagCompound compound) {
		this.position.set(compound.getInt("PosX"), compound.getInt("PosY"));
	}

	public void saveToCompound(TagCompound compound) {
		compound.setInt("PosX", this.position.getPosX());
		compound.setInt("PosY", this.position.getPosY());
	}

	public abstract EventType getType();

}
