package de.howaner.Pokemon.map.events;

import de.howaner.Pokemon.map.MapTerrain;
import de.howaner.Pokemon.saveformat.TagCompound;

public class EventEntity extends Event {
	private String textureName = "";
	private String scriptName = "";

	public EventEntity(MapTerrain map, int posX, int posY) {
		super(map, posX, posY);
	}

	public String getTextureName() {
		return this.textureName;
	}

	public void setTextureName(String textureName) {
		this.textureName = textureName;
	}

	public String getScriptName() {
		return this.scriptName;
	}

	public void setScriptName(String scriptName) {
		this.scriptName = scriptName;
	}

	@Override
	public void loadFromCompound(TagCompound compound) {
		super.loadFromCompound(compound);
		this.textureName = compound.getString("TextureName");
		this.scriptName = compound.getString("ScriptName");
	}

	@Override
	public void saveToCompound(TagCompound compound) {
		super.saveToCompound(compound);
		compound.setString("TextureName", this.textureName);
		compound.setString("ScriptName", this.scriptName);
	}

	@Override
	public EventType getType() {
		return EventType.ENTITY;
	}

}
