package de.howaner.Pokemon.map.events;

import de.howaner.Pokemon.map.MapTerrain;
import de.howaner.Pokemon.saveformat.TagCompound;

public class EventScript extends Event {
	private String scriptName = "";

	public EventScript(MapTerrain map, int posX, int posY) {
		super(map, posX, posY);
	}

	public String getScriptName() {
		return this.scriptName;
	}

	public void setScriptName(String scriptName) {
		this.scriptName = scriptName;
	}

	@Override
	public void loadFromCompound(TagCompound compound) {
		super.loadFromCompound(compound);
		this.scriptName = compound.getString("ScriptName");
	}

	@Override
	public void saveToCompound(TagCompound compound) {
		super.saveToCompound(compound);
		compound.setString("ScriptName", this.scriptName);
	}

	@Override
	public EventType getType() {
		return EventType.SCRIPT;
	}

}
