package de.howaner.Pokemon.map.events;

import de.howaner.Pokemon.map.MapTerrain;
import de.howaner.Pokemon.saveformat.TagCompound;
import de.howaner.Pokemon.util.Location;

public class EventWarp extends Event {
	private Location target;

	public EventWarp(MapTerrain map, int posX, int posY) {
		this(map, posX, posY, new Location("", 0, 0));
	}

	public EventWarp(MapTerrain map, int posX, int posY, Location target) {
		super(map, posX, posY);
		this.target = target;
	}

	public Location getTarget() {
		return this.target;
	}

	public void setTarget(Location target) {
		this.target = target;
	}

	@Override
	public void loadFromCompound(TagCompound compound) {
		super.loadFromCompound(compound);
		this.target.set(compound.getString("TargetWorld"), compound.getInt("TargetX"), compound.getInt("TargetY"));
	}

	@Override
	public void saveToCompound(TagCompound compound) {
		super.saveToCompound(compound);
		compound.setString("TargetWorld", this.target.getWorld());
		compound.setInt("TargetX", this.target.getPosX());
		compound.setInt("TargetY", this.target.getPosY());
	}

	@Override
	public EventType getType() {
		return EventType.WARP;
	}

}
