package de.howaner.Pokemon.network;

import com.google.common.collect.BiMap;
import com.google.common.collect.HashBiMap;
import de.howaner.Pokemon.network.packets.in.*;

public class Packets {
	private static BiMap<Integer, Class<? extends InPacket>> packets = HashBiMap.create();

	static {
		addPacket(0, PacketInKeepAlive.class);
		addPacket(1, PacketInLoginStart.class);
		addPacket(2, PacketInEncryptionKey.class);
		addPacket(3, PacketInAuthenticationResponse.class);
		addPacket(4, PacketInPlayerMove.class);
		addPacket(5, PacketInChangeFace.class);
		addPacket(6, PacketInChangeState.class);
	}

	public static InPacket createPacketInstance(int packetID) {
		Class<? extends InPacket> packetClass = getPacketClass(packetID);
		if (packetClass == null) {
			return null;
		}

		try {
			return packetClass.newInstance();
		} catch (Exception e) {
			return null;
		}
	}

	public static Class<? extends InPacket> getPacketClass(int packetID) {
		return packets.get(packetID);
	}

	public static void addPacket(int packetID, Class<? extends InPacket> packetClass) {
		packets.put(packetID, packetClass);
	}

}
