package de.howaner.Pokemon.network.netty;

import de.howaner.Pokemon.PokemonServer;
import de.howaner.Pokemon.network.PacketBuffer;
import de.howaner.Pokemon.network.packets.in.InPacket;
import de.howaner.Pokemon.network.Packets;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.ByteToMessageDecoder;
import java.util.List;

public class MessageDeserializer extends ByteToMessageDecoder {

	@Override
	protected void decode(ChannelHandlerContext ctx, ByteBuf in, List<Object> out) throws Exception {
		int readableBytes = in.readableBytes();
		if (readableBytes != 0) {
			PacketBuffer buffer = new PacketBuffer(in);
			int packetID = buffer.readVarInt();
			InPacket packet = Packets.createPacketInstance(packetID);

			if (packet == null) {
				throw new Exception("Unknown packet id: " + packetID);
			}

			packet.readPacketData(buffer);
			if (in.readableBytes() > 0) {
				throw new Exception("Packet was larger than I expected, found " + in.readableBytes() + " bytes extra whilst reading packet " + packetID);
			}

			out.add(packet);
		}
	}

}
