package de.howaner.Pokemon.network.netty;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToMessageDecoder;
import java.util.List;
import javax.crypto.Cipher;

public class NettyEncryptingDecoder extends MessageToMessageDecoder {
	private final Cipher cipher;
	private byte[] readCache = new byte[0];

	public NettyEncryptingDecoder(Cipher cipher) {
		this.cipher = cipher;
	}

	private byte[] readBytes(ByteBuf in) {
		int length = in.readableBytes();
		if (this.readCache.length < length) {
			this.readCache = new byte[length];
		}

		in.readBytes(this.readCache, 0, length);
		return this.readCache;
	}

	@Override
	protected void decode(ChannelHandlerContext ctx, Object msg, List out) throws Exception {
		if (!(msg instanceof ByteBuf)) {
			return;
		}
		ByteBuf in = (ByteBuf) msg;

		int length = in.readableBytes();
		byte[] bytes = this.readBytes(in);

		ByteBuf buf = ctx.alloc().heapBuffer(this.cipher.getOutputSize(length));
		buf.writerIndex(this.cipher.update(bytes, 0, length, buf.array(), buf.arrayOffset()));
		out.add(buf);
	}

}
