package de.howaner.Pokemon.network.packets.out;

import de.howaner.Pokemon.entity.Entity;
import de.howaner.Pokemon.entity.EntityFace;
import de.howaner.Pokemon.network.PacketBuffer;
import de.howaner.Pokemon.util.Location;

public class PacketOutEntityWalk extends OutPacket {
	private int entityID;
	private Location currentLoc;
	private EntityFace face;

	public PacketOutEntityWalk(int entityID, Location currentLoc, EntityFace face) {
		this.entityID = entityID;
		this.currentLoc = currentLoc;
		this.face = face;
	}

	public PacketOutEntityWalk(Entity entity) {
		this(entity.getEntityID(), entity.getLocation(), entity.getFace());
	}

	@Override
	public int getPacketID() {
		return 7;
	}

	@Override
	public void writePacketData(PacketBuffer buffer) throws Exception {
		buffer.writeVarInt(this.entityID);
		buffer.writeLocation(this.currentLoc, false);
		buffer.writeByte(this.face.ordinal());
	}

}
