package de.howaner.Pokemon.network.packets.out;

import de.howaner.Pokemon.network.PacketBuffer;

public class PacketOutFadeEntity extends OutPacket {
	private int entityID;
	private FadeType fadeType;
	private float duration;

	public PacketOutFadeEntity(int entityID, FadeType fadeType, float duration) {
		this.entityID = entityID;
		this.fadeType = fadeType;
		this.duration = duration;
	}

	@Override
	public int getPacketID() {
		return 9;
	}

	@Override
	public void writePacketData(PacketBuffer buffer) throws Exception {
		buffer.writeVarInt(this.entityID);
		buffer.writeByte(this.fadeType.ordinal());
		buffer.writeFloat(this.duration);
	}

	public enum FadeType {
		FADE_OUT, FADE_IN;
	}

}
