package de.howaner.Pokemon.network.packets.out;

import de.howaner.Pokemon.entity.Player;
import de.howaner.Pokemon.network.PacketBuffer;
import de.howaner.Pokemon.util.Location;

public class PacketOutLoginSuccess extends OutPacket {
	private int entityID;
	private Location location;

	public PacketOutLoginSuccess(Player player) {
		this(player.getEntityID(), player.getLocation());
	}

	public PacketOutLoginSuccess(int entityID, Location location) {
		this.entityID = entityID;
		this.location = location;
	}

	@Override
	public int getPacketID() {
		return 3;
	}

	@Override
	public void writePacketData(PacketBuffer buffer) throws Exception {
		buffer.writeVarInt(this.entityID);
		buffer.writeLocation(this.location, true);
	}

}
