package de.howaner.Pokemon.network.packets.out;

import de.howaner.Pokemon.entity.EntityFace;
import de.howaner.Pokemon.entity.Player;
import de.howaner.Pokemon.network.PacketBuffer;
import de.howaner.Pokemon.util.Location;

public class PacketOutPlayerSpawn extends OutPacket {
	private int entityID;
	private String userName;
	private Location location;
	private EntityFace face;

	public PacketOutPlayerSpawn(int entityID, String userName, Location location, EntityFace face) {
		this.entityID = entityID;
		this.userName = userName;
		this.location = location;
		this.face = face;
	}

	public PacketOutPlayerSpawn(Player player) {
		this(player.getEntityID(), player.getName(), player.getLocation(), player.getFace());
	}

	@Override
	public int getPacketID() {
		return 4;
	}

	@Override
	public void writePacketData(PacketBuffer buffer) throws Exception {
		buffer.writeVarInt(this.entityID);
		buffer.writeString(this.userName);
		buffer.writeLocation(this.location, true);
		buffer.writeByte(this.face.ordinal());
	}

}
