package de.howaner.Pokemon.world.listeners;

import de.howaner.Pokemon.entity.Player;
import de.howaner.Pokemon.listener.EventHandler;
import de.howaner.Pokemon.listener.EventPriority;
import de.howaner.Pokemon.listener.Listener;
import de.howaner.Pokemon.listener.event.entity.EntityStartWalkEvent;
import de.howaner.Pokemon.map.events.Event;
import de.howaner.Pokemon.map.events.EventType;
import de.howaner.Pokemon.map.events.EventWarp;
import de.howaner.Pokemon.util.Location;

public class WorldChangeListener implements Listener {

	@EventHandler (priority = EventPriority.LOW)
	public void onEntityStartWalk(EntityStartWalkEvent event) {
		if (event.isCancelled() || !(event.getEntity() instanceof Player)) {
			return;
		}

		Player player = (Player) event.getEntity();
		Location loc = event.getDestinition();

		Event e = player.getWorld().getEventAt(loc.getPosX(), loc.getPosY());
		if (e != null && e.getType() == EventType.WARP) {
			EventWarp warpEvent = (EventWarp) e;
			player.teleport(warpEvent.getTarget());
			event.setCancelled(true);
		}
	}

}
